-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}

local function init()
electrics.values['gear_doors_count'] = -1
electrics.values['gear_doors_pressure'] = 0
electrics.values['gear_doors_pressure_2'] = 0
electrics.values['gear_main_pressure'] = 0
electrics.values['gear_front_pressure'] = 0
electrics.values['lights_state'] = 0
electrics.values['bay_doors'] = 0
electrics.values['indicator_state'] = 0
electrics.values['bomb_number'] = 0
electrics.values['bomb_release1'] = 0
electrics.values['bomb_release2'] = 0
electrics.values['bomb_release3'] = 0
electrics.values['bomb_release4'] = 0
electrics.values['landinglights'] = 0
electrics.values['lowhighbeam'] = 0
electrics.values['prop_blur'] = 0


end

local function reset()
	init()
end

local function updateGFX(dt)
		--READ HERE:
		--To turn LEFT, set parking brake on and move steering past 50% to the left.
		--To turn RIGHT, set parking brake on and move steering past 50% to the right.
		
		if electrics.values['steering']<-0.5 then         --<- When steering right
			
			drivetrain.wheels[1].parkingTorque = 6000     --<- Set right wheel parking brake torque to 90000
			drivetrain.wheels[2].parkingTorque = 0		   --<- Set left wheel parking brake torque to 0. Left wheel has now no braking effectiveness.
			
		elseif electrics.values['steering']>0.5 then    --<- When steering left
		
			drivetrain.wheels[1].parkingTorque = 0	   --<- Set right wheel parking brake torque to 0. Right wheel has now no braking effectiveness.
			drivetrain.wheels[2].parkingTorque = 6000	   --<- Set left wheel parking brake torque to 90000	
			
		else											   --<- If steering is neutral
			
			drivetrain.wheels[1].parkingTorque = 9000     --< Return both wheels to their original parking brake effectiveness. This allows to still brake normally on landings.
			drivetrain.wheels[2].parkingTorque = 9000
			
		end
		
		print(bullettime.simulationSpeed)

		
-------------------------------------------------------------------------------------------------------------BOMBS and bomb bay doors-------------------------------------------------------		
		
		if electrics.values['turnsignal'] > 0.1 then     --<-- if right indicator is on

			if electrics.values['indicator_state'] < 0.1 then 

				electrics.values['indicator_state'] = 1
				electrics.values['bay_doors'] = 1
				
				if electrics.values['bay_doors'] > 0.5 then
				
					electrics.values['bomb_number'] = electrics.values['bomb_number'] + 1
				
				end
			
			end
			
		end
			
			
		if electrics.values['turnsignal'] < -0.1 then --<-- if left indicator is on

			if electrics.values['indicator_state'] > -0.1 then 
			
				electrics.values['indicator_state'] = -1
				electrics.values['bay_doors'] = 1 - electrics.values['bay_doors']
				
			end
			
		end

		if electrics.values['turnsignal'] > -0.1 and electrics.values['turnsignal'] < 0.1 then --<-- if indicators are off (centred)
			
			if electrics.values['indicator_state'] < -0.1 then 
			
				electrics.values['indicator_state'] = 0
				electrics.values['bay_doors'] = 0
				
			end
			
			if electrics.values['indicator_state'] > 0.1 then
			
				electrics.values['indicator_state'] = 0
				electrics.values['bay_doors'] = 1
				
				if electrics.values['bay_doors'] > 0.5 then
				
				electrics.values['bomb_number'] = electrics.values['bomb_number'] + 1
				
				end
			
			end
				
			
		end
		

		if electrics.values['bomb_number'] > 0.5 then
			
			electrics.values['bomb_release1'] = 1

		end

		if electrics.values['bomb_number'] > 1.5 then
			
			electrics.values['bomb_release2'] = 1

		end

		if electrics.values['bomb_number'] > 2.5 then
			
			electrics.values['bomb_release3'] = 1

		end
		
		if electrics.values['bomb_number'] > 3.5 then
			
			electrics.values['bomb_release4'] = 1

		end
				
		-------------------------------------------------------------------------------------------------------------LANDING GEAR and landing gear doors-------------------------------------
		
		if electrics.values['lights'] > 0.1 then --<--lights state is a dummy variable for lights which is locked to either 1 or 0.
			
			electrics.values['lights_state'] = 1  --<--lights state can only be either 1,
			
		end
		
		if electrics.values['lights'] < 0.1 then
			
			electrics.values['lights_state'] = 0  --<-- or zero
			
		end
			
		
		if electrics.values['rpm'] > 500 then --<-- don't allow gear to extend/retract if the engine is dead
		
			if electrics.values['gear_main_pressure'] ~= electrics.values['lights_state'] then --<-- if the gear position doesn't match the gear state,
				
				electrics.values['gear_main_pressure'] = 1 - electrics.values['gear_main_pressure'] --<-- activate gear hydros
				
				electrics.values['gear_doors_count'] = 0 --<-- start counting how long the gear doors open for
				
			end
	
		end
		
		if electrics.values['gear_doors_count'] > -0.5 then --<-- if the gear doors are open,
		
			
			if electrics.values['gear_main_pressure'] == 0 then
			
				electrics.values['gear_doors_pressure_2'] = 0
				
			end
			
			electrics.values['gear_doors_count'] = electrics.values['gear_doors_count'] + 1  --<-- keep counting how long they should be open for
			electrics.values['gear_doors_pressure'] = 1   --<-- apply opening pressure to gear doors while the count is happening
			
		end
		
		if electrics.values['gear_doors_count'] > 50 and electrics.values['gear_main_pressure'] < 0.5 then --<--slight delay in front gear extension
		
			electrics.values['gear_front_pressure'] = 0
			
		end
		
		if electrics.values['gear_main_pressure'] > 0.5 then
		
			electrics.values['gear_front_pressure'] = 1
		
		end
		
		if electrics.values['gear_doors_count'] > 200 then --<--once the count is over
		
			electrics.values['gear_doors_count'] = -1  --<-- disable the count 
			electrics.values['gear_doors_pressure'] = 0 --<-- close the gear doors
			
			if electrics.values['gear_main_pressure'] == 1 then
			
				electrics.values['gear_doors_pressure_2'] = 1
				
			end
				
			
		end
		
		-----------------------------------------------------------------------------------------------------------------
		
		           


		
end

-- public interface
M.init      = init
M.updateGFX = updateGFX

return M